.386
.model flat,stdcall
option casemap:none
WinMain proto :DWORD,:DWORD,:DWORD,:DWORD
include \masm32\include\windows.inc
include \masm32\include\user32.inc
include \masm32\include\kernel32.inc
include \masm32\include\gdi32.inc
includelib \masm32\lib\gdi32.lib
includelib \masm32\lib\user32.lib
includelib \masm32\lib\kernel32.lib

.data
ClassName db "SimpleWinClass",0
AppName  db "Our First Window",0
MenuName db "FirstMenu",0
Test_string db "You selected Test menu item",0
Hello_string db "Hello, my friend",0
Goodbye_string db "See you again, bye",0
Array_String db "%u ", 0

;; BLOCK DATA HERE
block_total     dd  10      ; total # of blocks
block_current   dd  10      ; offset to current block in memory (working temp)
block_width     dd  10      ; each block's width
block_height    dd  10      ; each block's height
Array_Buf db 64 dup (0)     ; TextOut string buffer
block_x dd  64 dup (0)      ; X positions
block_y dd  64 dup (0)      ; Y positions
block_c dd  64 dup (0)      ; Colors of blocks

.data?
hInstance HINSTANCE ?
CommandLine LPSTR ?

.const
IDM_TEST equ 1
IDM_HELLO equ 2
IDM_GOODBYE equ 3
IDM_EXIT equ 4
IDM_ARRAY equ 5

.code
start:
	invoke GetModuleHandle, NULL
	mov    hInstance,eax
	invoke GetCommandLine
	invoke WinMain, hInstance,NULL,CommandLine, SW_SHOWDEFAULT
	invoke ExitProcess,eax
WinMain proc hInst:HINSTANCE,hPrevInst:HINSTANCE,CmdLine:LPSTR,CmdShow:DWORD
	LOCAL wc:WNDCLASSEX
	LOCAL msg:MSG
	LOCAL hwnd:HWND
	mov   wc.cbSize,SIZEOF WNDCLASSEX
	mov   wc.style, CS_HREDRAW or CS_VREDRAW
	mov   wc.lpfnWndProc, OFFSET WndProc
	mov   wc.cbClsExtra,NULL
	mov   wc.cbWndExtra,NULL
	push  hInst
	pop   wc.hInstance
	mov   wc.hbrBackground,COLOR_WINDOW+1
	mov   wc.lpszMenuName,OFFSET MenuName
	mov   wc.lpszClassName,OFFSET ClassName
	invoke LoadIcon,NULL,IDI_APPLICATION
	mov   wc.hIcon,eax
	mov   wc.hIconSm,eax
	invoke LoadCursor,NULL,IDC_CROSS
	mov   wc.hCursor,eax
	invoke RegisterClassEx, addr wc
	INVOKE CreateWindowEx,NULL,ADDR ClassName,ADDR AppName,\
           WS_OVERLAPPEDWINDOW,CW_USEDEFAULT,\
           CW_USEDEFAULT,CW_USEDEFAULT,CW_USEDEFAULT,NULL,NULL,\
           hInst,NULL
	mov   hwnd,eax
	INVOKE ShowWindow, hwnd,SW_SHOWNORMAL
	INVOKE UpdateWindow, hwnd
	.WHILE TRUE
                INVOKE GetMessage, ADDR msg,NULL,0,0
                .BREAK .IF (!eax)
                INVOKE DispatchMessage, ADDR msg
	.ENDW
	mov     eax,msg.wParam
	ret
WinMain endp
WndProc proc hWnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM
	LOCAL hdc:HDC
	LOCAL ps:PAINTSTRUCT
	.IF uMsg==WM_DESTROY
		invoke PostQuitMessage,NULL
	.ELSEIF uMsg==WM_COMMAND
		mov eax,wParam
		.IF ax==IDM_TEST
                  ; set array equal to 100 to 164...
                  mov ecx, block_total
                  mov eax, 800
                  mov ebx, eax
                  mov edx, 0
                  div ecx
                  lea esi, block_x
            arrayjoy1:
                  mov [esi+ecx*4],ebx
                  sub ebx, eax
                  loop arrayjoy1
			invoke MessageBox,NULL,ADDR Test_string,OFFSET AppName,MB_OK
		.ELSEIF ax==IDM_HELLO
			invoke MessageBox, NULL,ADDR Hello_string, OFFSET AppName,MB_OK
		.ELSEIF ax==IDM_GOODBYE
			invoke MessageBox,NULL,ADDR Goodbye_string, OFFSET AppName, MB_OK
            .ELSEIF ax==IDM_ARRAY
        		invoke InvalidateRect,hWnd,NULL,TRUE
		.ELSE
			invoke DestroyWindow,hWnd
		.ENDIF
	.ELSEIF uMsg==WM_PAINT
		invoke BeginPaint,hWnd, ADDR ps
		mov    hdc,eax
            lea esi, block_x       ; move address of numb into esi
            mov ecx, block_total
            mov block_current,10
arrayjoy2:
            mov eax, [esi+ecx*4]    ; move value at esi+ecx*4 to eax
            push ecx
            invoke wsprintf,ADDR Array_Buf, ADDR Array_String, eax
            invoke lstrlen,ADDR Array_Buf
		invoke TextOut,hdc,block_current,100,ADDR Array_Buf,eax
            add block_current,45
            pop ecx
            loop arrayjoy2
		invoke EndPaint,hWnd, ADDR ps
	.ELSE
		invoke DefWindowProc,hWnd,uMsg,wParam,lParam
		ret
	.ENDIF
	xor    eax,eax
	ret
WndProc endp
end start
